package cn.com.infosec.crypto.prng;

import cn.com.infosec.crypto.Digest;

public class DigestRandomGenerator implements RandomGenerator {
   private long counter;
   private Digest digest;
   private byte[] state;

   public DigestRandomGenerator(Digest digest) {
      this.digest = digest;
      this.state = new byte[digest.getDigestSize()];
      this.counter = 1L;
   }

   private void digestUpdate(long seed) {
      for(int var3 = 0; var3 != 8; ++var3) {
         this.digest.update((byte)((int)seed));
         seed >>>= 8;
      }

   }

   private void digestUpdate(byte[] inSeed) {
      this.digest.update(inSeed, 0, inSeed.length);
   }

   private void digestDoFinal(byte[] result) {
      this.digest.doFinal(result, 0);
   }

   public void addSeedMaterial(byte[] inSeed) {
      DigestRandomGenerator var10000 = this;
      DigestRandomGenerator var10001 = this;
      byte[] var10002 = inSeed;
      synchronized(this) {
         var10001.digestUpdate(var10002);
      }
   }

   public void addSeedMaterial(long rSeed) {
      synchronized(this){}
      int var3 = 0;

      while(true) {
         Throwable var10000;
         boolean var10001;
         if (var3 == 8) {
            try {
               return;
            } catch (Throwable var8) {
               var10000 = var8;
               var10001 = false;
               throw var10000;
            }
         } else {
            DigestRandomGenerator var10 = this;
            long var10002 = (long)((byte)((int)rSeed));

            try {
               var10.digestUpdate(var10002);
            } catch (Throwable var9) {
               var10000 = var9;
               var10001 = false;
               throw var10000;
            }

            rSeed >>>= 8;
            ++var3;
         }
      }
   }

   public void nextBytes(byte[] bytes) {
      DigestRandomGenerator var10000 = this;
      int var2 = bytes.length;
      var10000.nextBytes(bytes, 0, var2);
   }

   public void nextBytes(byte[] bytes, int start, int len) {
      int var10001 = len;
      DigestRandomGenerator var10002 = this;
      DigestRandomGenerator var10003 = this;
      synchronized(this){}
      len = 0;

      Throwable var10000;
      boolean var81;
      try {
         var10002.digestDoFinal(var10003.state);
      } catch (Throwable var78) {
         var10000 = var78;
         var81 = false;
         throw var10000;
      }

      DigestRandomGenerator var82;
      DigestRandomGenerator var84;
      DigestRandomGenerator var10004;
      for(int var4 = start + var10001; start != var4; ++start) {
         int var80;
         try {
            var80 = len;
            var10001 = this.state.length;
         } catch (Throwable var77) {
            var10000 = var77;
            var81 = false;
            throw var10000;
         }

         if (var80 == var10001) {
            DigestRandomGenerator var10005;
            long var10006;
            try {
               var82 = this;
               var84 = this;
               var10002 = this;
               var10003 = this;
               var10004 = this;
               var10005 = this;
               var10006 = this.counter;
            } catch (Throwable var76) {
               var10000 = var76;
               var81 = false;
               throw var10000;
            }

            long var5 = var10006++;

            try {
               var10005.counter = var10006;
               var10004.digestUpdate(var5);
               var10002.digestUpdate(var10003.state);
               var82.digestDoFinal(var84.state);
            } catch (Throwable var75) {
               var10000 = var75;
               var81 = false;
               throw var10000;
            }

            len = 0;
         }

         byte[] var83;
         byte[] var85;
         try {
            var83 = bytes;
            var10001 = start;
            var85 = this.state;
         } catch (Throwable var74) {
            var10000 = var74;
            var81 = false;
            throw var10000;
         }

         int var86 = len++;

         try {
            var83[var10001] = var85[var86];
         } catch (Throwable var73) {
            var10000 = var73;
            var81 = false;
            throw var10000;
         }
      }

      long var87;
      try {
         var82 = this;
         var84 = this;
         var10002 = this;
         var10003 = this;
         var10004 = this;
         var87 = this.counter;
      } catch (Throwable var72) {
         var10000 = var72;
         var81 = false;
         throw var10000;
      }

      long bytes1 = var87++;

      try {
         var10004.counter = var87;
         var10003.digestUpdate(bytes1);
         var84.digestUpdate(var10002.state);
      } catch (Throwable var71) {
         var10000 = var71;
         var81 = false;
         throw var10000;
      }
   }
}
